123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206 |
- #!/bin/sh
- #
- # asterisk: Starts the asterisk service
- #
- # Version: @(#) /etc/rc.d/init.d/asterisk 1.0
- #
- # chkconfig: 2345 95 10
- # description: Starts the asterisk service
- #
- # processname: asterisk
- #
- ### BEGIN INIT INFO
- # Provides: asterisk
- # Required-Start: $network $syslog $named $local_fs $remote_fs
- # Required-Stop: $network $syslog $named $local_fs $remote_fs
- # Should-Start: dahdi misdn lcr wanrouter mysql postgresql
- # Should-Stop: dahdi misdn lcr wanrouter mysql postgresql
- # Default-Start: 2 3 4 5
- # Default-Stop: 0 1 6
- # Short-Description: Asterisk PBX
- # Description: the Asterisk Open Source PBX
- ### END INIT INFO
- # $Id$
- TTY=9 # TTY (if you want one) for Asterisk to run on
- CONSOLE=yes # Whether or not you want a console
- NOTIFY=root # Who to notify about crashes
- DUMPDROP=/tmp
- HOSTNAME=`hostname`
- ASTSBINDIR=/usr/sbin
- if [ 0`readlink $0` = "0" ]; then
- CONFIGFILE=/etc/sysconfig/`basename $0`
- else
- CONFIG0=`readlink $0`
- CONFIGFILE=/etc/sysconfig/`basename $CONFIG0`
- fi
- # Setup environment
- cd /usr/src
- if [ -f /usr/lib/asterisk/modules/chan_h323.so -a `grep -c ^noload=chan_h323.so /etc/asterisk/modules.conf` -eq 0 ]; then
- OPENH323DIR=/usr/src/h323/openh323
- PWLIBDIR=/usr/src/h323/pwlib
- else
- OPENH323DIR=/usr/src/oh323/openh323
- PWLIBDIR=/usr/src/oh323/pwlib
- fi
- # Put overrides in /etc/sysconfig/asterisk
- [ -r $CONFIGFILE ] && . $CONFIGFILE
- LD_LIBRARY_PATH=$OPENH323DIR/lib:$PWLIBDIR/lib
- export OPENH323DIR PWLIBDIR LD_LIBRARY_PATH
- # Source function library.
- . /etc/rc.d/init.d/functions
- #
- # Don't fork when running "safely"
- #
- ASTARGS="-p"
- if [ "$TTY" != "" ]; then
- if [ -c /dev/tty${TTY} ]; then
- TTY=tty${TTY}
- elif [ -c /dev/vc/${TTY} ]; then
- TTY=vc/${TTY}
- else
- echo "Cannot find your TTY (${TTY})" >&2
- exit 1
- fi
- ASTARGS="${ASTARGS} -vvv"
- if [ "$CONSOLE" != "no" ]; then
- ASTARGS="${ASTARGS} -c"
- fi
- fi
- if [ ! -w ${DUMPDROP} ]; then
- echo "Cannot write to ${DUMPDROP}" >&2
- exit 1
- fi
- #
- # Let Asterisk dump core
- #
- ulimit -c unlimited
- #launch_asterisk()
- #{
- #}
- SIGMSG=("None", "Hangup" "Interrupt" "Quit" "Illegal instruction" "Trace trap" "IOT Trap" "Bus Error" "Floating-point exception" "Killed" "User-defined signal 1" "Segmentation violation" "User-defined signal 2" "Broken pipe" "Alarm clock" "Termination" "Stack fault")
- run_asterisk()
- {
- while :; do
- if [ "$TTY" != "" ]; then
- cd /tmp
- stty sane < /dev/${TTY}
- asterisk ${ASTARGS} > /dev/${TTY} 2>&1 < /dev/${TTY}
- else
- cd /tmp
- asterisk ${ASTARGS}
- fi
- EXITSTATUS=$?
- echo "Asterisk ended with exit status $EXITSTATUS"
- if [ "$EXITSTATUS" = "0" ]; then
- # Properly shutdown....
- echo "Asterisk shutdown normally."
- exit 0
- elif [ $EXITSTATUS -gt 128 ]; then
- EXITSIGNAL=$(($EXITSTATUS - 128))
- EXITMSG=${SIGMSG[$EXITSIGNAL]}
- echo "Asterisk exited on signal $EXITSIGNAL - $EXITMSG."
- if [ "$NOTIFY" != "" ]; then
- echo "Asterisk exited on signal $EXITSIGNAL - $EXITMSG. Might want to take a peek." | \
- mail -s "Asterisk Died ($HOSTNAME)" $NOTIFY
- fi
- if [ -f /tmp/core ]; then
- mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
- fi
- else
- echo "Asterisk died with code $EXITSTATUS. Aborting."
- if [ -f /tmp/core ]; then
- mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
- fi
- exit 0
- fi
- echo "Automatically restarting Asterisk."
- done
- }
- case "$1" in
- start)
- # Check if Asterisk is already running. If it is, then bug out, because
- # starting Asterisk when Asterisk is already running is very bad.
- VERSION=`${ASTSBINDIR}/asterisk -rx 'core show version' 2>/dev/null`
- if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
- echo "Asterisk is already running. $0 will exit now."
- exit 1
- fi
- gprintf "Starting asterisk: "
- run_asterisk >/dev/null 2>&1 &
- sleep 2 # Give it time to die
- succeeded=`pidof asterisk|awk '{print NF}'`
- if [ $succeeded = "0" ]; then
- failure
- else
- success
- fi
- echo
- ;;
- stop)
- gprintf "Stopping asterisk: "
- asterisk -r -x "core stop gracefully" >/dev/null 2>&1
- killall -9 mpg123 2>/dev/null
- success
- echo
- ;;
- restart)
- $0 stop
- usleep 100000
- $0 start
- ;;
- reload)
- gprintf "Reloading asterisk: "
- asterisk -r -x "module reload" >/dev/null 2>&1
- success
- echo
- ;;
- stopnow)
- gprintf "Stopping asterisk: "
- asterisk -r -x "core stop now" >/dev/null 2>&1
- success
- echo
- ;;
- restartnow)
- $0 stopnow
- $0 start
- ;;
- fullrestart)
- $0 stop
- service dahdi restart
- $0 start
- ;;
- fullrestartnow)
- $0 stopnow
- service dahdi restart
- $0 start
- ;;
- status)
- succeeded=`pidof asterisk|awk '{print NF}'`
- if [ $succeeded = "0" ]; then
- echo "Asterisk is not running"
- else
- echo "Asterisk is currently running with $succeeded threads"
- fi
- ;;
- *)
- gprintf "*** Usage: $0 {start|stop[now]|reload|[full]restart[now]|status}\n"
- exit 1
- esac
- exit 0
|